// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int dx[4] = {0, 1, 0, -1};
int dy[4] = {1, 0, -1, 0};

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n, m;
	cin >> n >> m;
	vector<vector<int>> field(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			field[i][j] = s[j] == '.' ? -1 : s[j] - '0';
		}
	}

	vector<string> outp(n, string(m, '.'));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (field[i][j] == -1) {
				continue;
			}
			int ox = i, oy = j;
			if (field[i][j] == 0 || field[i][j] == 2) {
				++ox;
			} else {
				++oy;
			}

			assert(field[ox][oy] == field[i][j]);

			char fromc = 'a', toc = 'z';
			if (field[i][j] >= 2) {
				fromc = 'A';
				toc = 'Z';
			}

			set<char> used;
			for (auto p : vector<pii>({{i, j}, {ox, oy}})) {
				for (int d = 0; d < 4; ++d) {
					int nx = p.ff + dx[d];
					int ny = p.ss + dy[d];
					if (0 <= nx && nx < n && 0 <= ny && ny < m && outp[nx][ny] != '.') {
						used.insert(outp[nx][ny]);
					}
				}
			}

			char c;
			while (true) {
				c = rnd.next(fromc, toc);
				if (!used.count(c)) {
					break;
				}
			}
			field[i][j] = field[ox][oy] = -1;
			outp[i][j] = outp[ox][oy] = c;
		}
	}

	cout << n << " " << m << "\n";
	for (int i = 0; i < n; ++i) {
		cout << outp[i] << "\n";
	}

	return 0;
}