import java.io.PrintWriter

fun main() {
	val (hei, wid) = readInts()
	val field = List(hei) { readLn() }
	val wanted = IntArray(2 * hei * wid) { -1 }
	fun add(x: Int, value: Int) {
		if (wanted[2 * x] == -1) wanted[2 * x] = value else wanted[2 * x + 1] = value
	}
	for (i in 0 until hei) {
		for (j in 0 until wid) {
			val id = i * wid + j
			if (field[i][j] == '.') continue
			for (dir in 0..1) {
				val notDir = 1 - dir
				val i2 = i + notDir; val j2 = j + dir
				if (i2 >= hei || j2 >= wid || field[i2][j2] != field[i][j]) continue
				add(id, id)
				add(i2 * wid + j2, id)
				val k = if (field[i][j].isUpperCase()) 1 else -1
				var possible = true
				for (t in 0..1) {
					val i3 = i + t * notDir + k * dir
					val j3 = j + t * dir + k * notDir
					if (i3 !in 0 until hei || j3 !in 0 until wid || field[i3][j3] != '.') possible = false
				}
				if (!possible) continue
				for (t in 0..1) {
					val i3 = i + t * notDir + k * dir
					val j3 = j + t * dir + k * notDir
					add(i3 * wid + j3, id)
				}
			}
		}
	}
	val nei = IntArray(2 * hei * wid) { -1 }
	fun addNei(a: Int, b: Int) {
		if (nei[2 * a] == -1) {
			nei[2 * a] = b
			return
		}
		if (nei[2 * a] == b || nei[2 * a + 1] == b) return
		nei[2 * a + 1] = b
	}
	for (i in 0 until hei * wid) {
		if (wanted[2 * i + 1] == -1) continue
		val a = wanted[2 * i]
		val b = wanted[2 * i + 1]
		addNei(a, b); addNei(b, a)
	}
	val color = IntArray(hei * wid)
	val temp = IntArray(2)
	for (i in 0 until hei * wid) {
		if (color[i] > 0 || nei[2 * i] == -1) continue
		var j = i
		var prev = -1
		while (true) {
			temp[0] = nei[2 * j]; temp[1] = nei[2 * j + 1]
			val next = temp.firstOrNull { it != -1 && it != prev && it != i } ?: break
			prev = j
			j = next
		}
		color[j] = 1
		val jInit = j
		prev = -1
		while (true) {
			temp[0] = nei[2 * j]; temp[1] = nei[2 * j + 1]
			val next = temp.firstOrNull { it != -1 && it != prev && it != jInit } ?: break
			color[next] = 3 - color[j]
			prev = j
			j = next
		}
	}
	val digit = IntArray(hei * wid) { -1 }
	val count = IntArray(hei * wid) { 0 }
	val ans = List(hei) { i ->
		CharArray(wid) { j ->
			val index = 2 * (i * wid + j)
			val id = if (field[i][j] != '.') {
				wanted[index]
			} else {
				temp[0] = wanted[index]; temp[1] = wanted[index + 1]
				temp.firstOrNull { it >= 0 && color[it] != 2 } ?: -1
			}
			if (id == -1) '.' else {
				if (digit[id] == -1) digit[id] = 3 * (i % 3) + j % 3
				count[id]++
				'0' + digit[id]
			}
		}.concatToString()
	}
	val out = PrintWriter(System.out)
	out.println(count.count { it == 4 })
	for (s in ans) out.println(s)
	out.close()
}

private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }
