#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const int S = 1003;
//const int S = 13;
const int N = S * S;
int w, h;
char s[S][S];
char A[S][S];
bool uu[S][S];
int n, m;
vector<int> g[N];
vector<int> G[N];
bool used[N];
bool inQ[N];
vector<pii> ans;

bool checkCell(int x, int y) {
	return 0 <= x && x < w && 0 <= y && y < h;
}

bool isUpper(char c) {
	return 'A' <= c && c <= 'Z';
}

void read() {
	scanf("%d%d", &w, &h);
	for (int i = 0; i < w; i++)
		scanf("%s", s[i]);
	for (int x = 0; x < w; x++)
		for (int y = 0; y < h; y++) {
			if (s[x][y] == '.' || uu[x][y]) continue;
			if (checkCell(x + 1, y) && s[x][y] == s[x + 1][y]) {
				assert(!uu[x + 1][y]);
				uu[x][y] = uu[x + 1][y] = 1;
				int ny = y;
				if ('A' <= s[x][y] && s[x][y] <= 'Z')
					ny++;
				else
					ny--;
				if (!checkCell(x, ny)) continue;
				if (s[x][ny] != '.' || s[x + 1][ny] != '.') continue;
				int v = x * S + ny, u = (x + 1) * S + ny;
				g[v].push_back(u);
				g[u].push_back(v);
			} else if (checkCell(x, y + 1) && s[x][y] == s[x][y + 1]) {
				assert(!uu[x][y + 1]);
				uu[x][y] = uu[x][y + 1] = 1;
				int nx = x;
				if (isUpper(s[x][y]))
					nx++;
				else
					nx--;
				if (!checkCell(nx, y)) continue;
				if (s[nx][y] != '.' || s[nx][y + 1] != '.') continue;
				int v = nx * S + y, u = nx * S + (y + 1);
				g[v].push_back(u);
				g[u].push_back(v);
			} else assert(false);
		}
}

void putRect(int x1, int y1, int x2, int y2) {
	for (int x = x1; x < x2; x++)
		for (int y = y1; y < y2; y++)
			assert(A[x][y] == '.');
	int mask = 0;
	for (int x = x1 - 1; x < x2 + 1; x++)
		for (int y = y1 - 1; y < y2 + 1; y++) {
			if ((x < x1 || x >= x2) && (y < y1 || y >= y2)) continue;
			if (!checkCell(x, y)) continue;
			if (A[x][y] == '.') continue;
			mask |= 1 << (int)(A[x][y] - '0');
		}
	int p = 0;
	while((mask >> p) & 1) p++;
	for (int x = x1; x < x2; x++)
		for (int y = y1; y < y2; y++) {
			A[x][y] = '0' + p;
		}
}

void solve() {
	vector<int> Q;
	for (int v = 0; v < N; v++) {
		assert((int)g[v].size() <= 2);
		if ((int)g[v].size() == 1) {
			inQ[v] = 1;
			Q.push_back(v);
		}
	}
	for (int i = 0; i < (int)Q.size(); i++) {
		int v = Q[i];
		int u = -1;
		for (int x : g[v]) {
			if (used[x]) continue;
			u = x;
		}
		if (u == -1) continue;
		if (!used[v]) {
			ans.push_back(mp(v, u));
			used[v] = used[u] = 1;
		}
		inQ[u] = 1;
		for (int x : g[u]) {
			if (!inQ[x]) {
				inQ[x] = 1;
				Q.push_back(x);
			}
		}
	}
	for (int v = 0; v < N; v++) {
		if ((int)g[v].size() < 2 || inQ[v]) continue;
		int u = g[v][0];
		while(!used[v]) {
			u ^= g[v][0] ^ g[v][1];
			used[v] = used[u] = 1;
			ans.push_back(mp(v, u));
			v ^= g[u][0] ^ g[u][1];
		}
	}
}

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	read();
	solve();
	printf("%d\n", (int)ans.size());
	for (int x = 0; x < w; x++) {
		for (int y = 0; y < h; y++) {
			A[x][y] = '.';
			uu[x][y] = 0;
		}
		A[x][h] = '\0';
	}
	for (pii mm : ans) {
		int v = mm.first, u = mm.second;
		int x1 = v / S, y1 = v % S, x2 = u / S, y2 = u % S;
		if (x1 + y1 > x2 + y2) {
			swap(x1, x2);
			swap(y1, y2);
		}
		if (x1 == x2) {
			assert(y2 == y1 + 1);
			if (checkCell(x1 - 1, y1) && s[x1 - 1][y1] == s[x1 - 1][y2] && isUpper(s[x1 - 1][y1])) {
				uu[x1 - 1][y1] = uu[x1 - 1][y2] = 1;
				putRect(x1 - 1, y1, x1 + 1, y2 + 1);
			} else if (checkCell(x1 + 1, y1) && s[x1 + 1][y1] == s[x1 + 1][y2] && !isUpper(s[x1 + 1][y1])) {
				uu[x1 + 1][y1] = uu[x1 + 1][y2] = 1;
				putRect(x1, y1, x1 + 2, y2 + 1);
			} else assert(false);
		} else if (y1 == y2) {
			assert(x2 == x1 + 1);
			if (checkCell(x1, y1 - 1) && s[x1][y1 - 1] == s[x2][y1 - 1] && isUpper(s[x1][y1 - 1])) {
				uu[x1][y1 - 1] = uu[x2][y1 - 1] = 1;
				putRect(x1, y1 - 1, x2 + 1, y1 + 1);
			} else if (checkCell(x1, y1 + 1) && s[x1][y1 + 1] == s[x2][y1 + 1] && !isUpper(s[x1][y1 + 1])) {
				uu[x1][y1 + 1] = uu[x2][y1 + 1] = 1;
				putRect(x1, y1, x2 + 1, y1 + 2);
			} else assert(false);
		} else assert(false);
	}
	for (int x = 0; x < w; x++)
		for (int y = 0; y < h; y++) {
			if (s[x][y] == '.' || uu[x][y]) continue;
			if (checkCell(x + 1, y) && s[x][y] == s[x + 1][y]) {
				assert(!uu[x + 1][y]);
				uu[x][y] = uu[x + 1][y] = 1;
				putRect(x, y, x + 2, y + 1);
			} else if (checkCell(x, y + 1) && s[x][y + 1] == s[x][y + 1]) {
				assert(!uu[x][y + 1]);
				uu[x][y] = uu[x][y + 1] = 1;
				putRect(x, y, x + 1, y + 2);
			} else assert(false);
		}
	for (int i = 0; i < w; i++)
		printf("%s\n", A[i]);

	return 0;
}
