#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <map>
#include <set>
#include <complex>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <random>

#define ft first
#define sc second
#define pb push_back
#define len(v) (int)v.size()
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;

int inf = 1e16 + 100;

struct edge {
	int from, to, f, c, cost;
};
vector<edge> have;
vector<vector<int>> g;

int calc(int s, int t, int n, int &flow) {
	vector<int> dst(n + 1, inf);
	vector<pair<int, int>> pr(n + 1, {-1, -1});
	dst[s] = 0;
	while(1) {
		bool flag = 1;
		for (int i = 0; i < len(have); i++) {
			auto x = have[i];
			if(x.c - x.f == 0) 
				continue;
			if(dst[x.from] == inf) 
				continue;
			if(dst[x.to] > dst[x.from] + x.cost) {
				dst[x.to] = dst[x.from] + x.cost;
				pr[x.to] = {x.from, i};
				flag = 0;
			}
		}
		if(flag) 
			break;
	}
	if(dst[t] == inf) 
		return -1;
	vector<int> ed;
	int now = t;
	int minn = inf;
	int ans = 0;
	while(now != s) {
		ed.pb(pr[now].sc);
		minn = min(minn, have[pr[now].sc].c - have[pr[now].sc].f);
		now = pr[now].ft;
	}
	flow += minn;
	for (auto x : ed) {
		have[x].f += minn;
		have[x^1].f -= minn;
		ans += minn * have[x].cost;
	}
	return ans;
}

void add_edge(int a, int b, int c, int cost) {
	g[a].pb(len(have));
	have.pb({a, b, 0, c, cost});
	g[b].pb(len(have));
	have.pb({b, a, 0, 0, -cost});
}


signed main() {
	#ifdef PC
		freopen("in.txt", "r", stdin);
		freopen("out.txt", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int m;
	cin >> m;
	vector<int> a(m + 1, 0);
	vector<vector<int>> c(m + 1, vector<int> (m + 1, 0));
	int sum = 0;
	for (int i = 1; i <= m; i++) {
		cin >> a[i];
		sum += a[i];
	}
	if (sum % 2 == 1) {
		cout << -1;
		return 0;
	}
	sum /= 2;
	for (int i = 1; i <= m; i++) {
		for (int j = 1; j <= m; j++) {
			cin >> c[i][j];
		}
	}	
	int anss = inf;

	for (int msk = 0; msk < (1 << m); msk++) {
		int n = 2 * m + 5;
		int s = 0, t = 2 * m + 2;
		g.clear(), have.clear();
		g = vector<vector<int>> (n);
		for (int i = 1; i <= m; i++) {
			int x = a[i];
			if ((msk | (1 << (i - 1))) == msk) {
				add_edge(s, i, x / 2, 0);
				add_edge(m + i, t, (x + 1) / 2, 0);
			}
			else {
				add_edge(s, i, (x + 1) / 2, 0);
				add_edge(m + i, t, x / 2, 0);
			}
		}
		for (int i = 1; i <= m; i++) {
			for (int j = 1; j <= m; j++) {
				add_edge(i, m + j, inf, c[i][j]);
			}
		}
		int ans = 0, flow = 0;
		while(1) {
			int plus = calc(s, t, n, flow);
			if(plus == -1) 
				break;
			ans += plus;
		}
		if (flow != sum) {
			continue;
		}
		anss = min(anss, ans);
	}
	cout << anss << endl;
	return 0;
}