#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const int INF = (int)1e9;

struct Edge {
	int v, to, cap, cost;

	Edge() : v(), to(), cap(), cost() {}
	Edge(int _v, int _to, int _cap, int _cost) : v(_v), to(_to), cap(_cap), cost(_cost) {}
};
const int SS = 11;
const int N = 555;
Edge ed[N];
int edSz;
int C[SS][SS];
int a[SS];
int n;
int S, T;
int dist[N];
int par[N];

void addEdge(int v, int to, int cap, int cost) {
	ed[edSz++] = Edge(v, to, cap, cost);
	ed[edSz++] = Edge(to, v, 0, -cost);
}

void addBase() {
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			addEdge(2 * i, 2 * j + 1, INF, C[i][j]);
}

int pushFlow() {
	for (int i = 0; i <= T; i++)
		dist[i] = INF;
	dist[S] = 0;
	bool ch = true;
	while(ch) {
		ch = false;
		for (int id = 0; id < edSz; id++) {
			Edge e = ed[id];
			if (e.cap <= 0) continue;
			int to = e.to;
			int w = dist[e.v] + e.cost;
			if (dist[to] <= w) continue;
			ch = true;
			dist[to] = w;
			par[to] = id;
		}
	}
	assert(dist[T] < INF);
	int v = T;
	while(v != S) {
		int id = par[v];
		ed[id].cap--;
		ed[id ^ 1].cap++;
		v = ed[id].v;
	}
	return dist[T];
}

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	scanf("%d", &n);
	int tot = 0;
	for (int i = 0; i < n; i++) {
		scanf("%d", &a[i]);
		tot += a[i];
	}
	if (tot & 1) {
		printf("-1\n");
		return 0;
	}
	tot /= 2;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			scanf("%d", &C[i][j]);
	S = 2 * n;
	T = 2 * n + 1;
	int ans = INF;
	for (int mask = 0; mask < (1 << n); mask++) {
		edSz = 0;
		addBase();
		int bal = 0;
		for (int v = 0; v < n; v++) {
			if (a[v] % 2 == 0) {
				if ((mask >> v) & 1) {
					bal = 100;
					break;
				}
				addEdge(S, 2 * v, a[v] / 2, 0);
				addEdge(2 * v + 1, T, a[v] / 2, 0);
			} else {
				int x = a[v] / 2, y = a[v] / 2;
				if ((mask >> v) & 1)
					x++;
				else
					y++;
				bal += x - y;
				addEdge(S, 2 * v, x, 0);
				addEdge(2 * v + 1, T, y, 0);
			}
		}
		if (bal != 0) continue;
		int res = 0;
		for (int i = 0; i < tot; i++) {
			res += pushFlow();
		}
		ans = min(ans, res);
	}
	printf("%d\n", ans);

	return 0;
}
