#include <iostream>
#include <string>

using namespace std;

unsigned long long stoll2(string const &s) {
    unsigned long long value = 0;
    for (char c : s) {
        value = value * 10 + (c - '0');
    }
    return value;
}

unsigned int common;
string s_common;

pair<unsigned int, unsigned int> longest_common(string const &l, string const &r) {
    if (common == 0) {
        return {0, 0};
    }

    unsigned int len = 1, res = 1;
    for (unsigned int i = 1; i < common; i++) {
        if (l[i] == l[i - 1]) {
            len++;
        } else {
            len = 1;
        }
        res = max(res, len);
    }
    return {res, stoll2(r) - stoll2(l) + 1};
}

pair<unsigned int, unsigned int> longest_right(string const &l, string const &r) {
    if (common == l.length()) {
        return {0, 0};
    }
    char c = l[common];
    unsigned long long ll = stoll2(l), rr = stoll2(r);

    string first = s_common + string(l.length() - common, c);
    string second = s_common + string(l.length() - common, c + 1);
    string last = s_common + string(r.length() - common, r[common]);

    bool ff = stoll2(first) >= ll, fs = stoll2(second) <= rr, fl = stoll2(last) <= rr;
    if (ff || fs) {
        return {l.length() - common, r[common] - l[common] - 1 + ff + fl};
    } else {
        unsigned int len = l.length() - common - 1;
        if (len == 1) {
            return {len, rr - ll + 1};
        }
        unsigned int cnt = 0;
        for (unsigned int i = 0; i < 2; i++) {
            for (char c1 = '0'; c1 <= '9'; c1++) {
                if (s_common.empty() && i == 1 && c1 == '0') {
                    continue;
                }
                string add = string(len, c1);
                for (char c2 = '0'; c2 <= '9'; c2++) {
                    string s = i == 0 ? s_common + c2 + add : s_common + add + c2;
                    unsigned long long value = stoll2(s);
                    if (value >= ll && value <= rr) {
                        cnt++;
                    }
                }
            }
        }
        return {len, cnt};
    }
}

pair<unsigned int, unsigned int> longest_middle(string const &l, string const &r) {
    if (common == 0 || common == l.length()) {
        return {0, 0};
    }
    char c = l[common - 1];
    if (c < l[common] || c > r[common]) {
        return {0, 0};
    }

    unsigned int left = common - 1;
    while (left > 0 && l[left - 1] == l[left]) {
        left--;
    }
    unsigned int right_l = common, right_r = common;
    while (right_l < l.length() && l[right_l] == c) {
        right_l++;
    }
    while (right_r < r.length() && r[right_r] == c) {
        right_r++;
    }
    if (right_l == l.length() || l[right_l] > c) {
        string rr = s_common + string(right_l - common, c) + string(l.length() - right_l, '9');
        return {right_l - left, stoll2(rr) - stoll2(l) + 1};
    }
    if (right_r == r.length() || r[right_r] < c) {
        string ll = s_common + string(right_r - common, c) + string(r.length() - right_r, '0');
        return {right_r - left, stoll2(r) - stoll2(ll) + 1};
    }
    return {l.length() - left, 1};
}

int main() {

    int tests;
    for (cin >> tests; tests > 0; tests--) {
        string l, r;
        cin >> l >> r;

        if (r.length() > l.length()) {
            string zero(r.length() - l.length(), '0');
            l = zero + l;
        }
        common = 0;
        while (common < l.length() && l[common] == r[common]) {
            common++;
        }
        s_common = l.substr(0, common);

        auto lc = longest_common(l, r);
        auto lr = longest_right(l, r);
        auto lm = longest_middle(l, r);

        if (lc.first >= lr.first && lc.first >= lm.first) {
            cout << lc.first << ' ' << lc.second << '\n';
        } else {
            if (lr.first > lm.first) {
                cout << lr.first << ' ' << lr.second << '\n';
            } else if (lm.first > lr.first) {
                cout << lm.first << ' ' << lm.second << '\n';
            } else {
                unsigned int cnt = lm.second + lr.second;
                if (lr.first < l.length() - common) {
                    unsigned int left = common - 1;
                    while (left > 0 && l[left - 1] == l[left]) {
                        left--;
                    }
                    string base = s_common + string(lm.first - common + left, l[common - 1]);
                    for (char c = '0'; c <= '9'; c++) {
                        string s = base + string(l.length() - common - 1, c);
                        unsigned long long value = stoll2(s);
                        if (value >= stoll2(l) && value <= stoll2(r)) {
                            cnt--;
                        }
                    }
                }
                cout << lm.first << ' ' << cnt << '\n';
            }
        }
    }

}