#include <iostream>
#include <string>

using namespace std;

unsigned long long stoll2(string const &s) {
    unsigned long long value = 0;
    for (char c : s) {
        value = value * 10 + (c - '0');
    }
    return value;
}

int main() {

    int tests;
    for (cin >> tests; tests > 0; tests--) {
        string l, r;
        cin >> l >> r;

        if (r.length() > l.length()) {
            string zero(r.length() - l.length(), '0');
            l = zero + l;
        }

        unsigned int common = 0;
        while (common < l.length() && l[common] == r[common]) {
            common++;
        }

        for (unsigned int len = l.length(); len > 0; len--) {
            unsigned long long cnt = 0;
            for (unsigned int i = 0; i + len <= l.length(); i++) {
                if (i <= common) {
                    for (char c = '0'; c <= '9'; c++) {
                        if (i == 0 && c == '0') {
                            continue;
                        }
                        bool ok = true, l_lt = false, r_gt = false;
                        for (unsigned int t = i; t < i + len; t++) {
                            if (t < common && (l[t] != c || r[t] != c)) {
                                ok = false;
                            } else if (t >= common && ok) {
                                if (!l_lt) {
                                    if (l[t] < c) {
                                        l_lt = true;
                                    } else if (l[t] > c) {
                                        ok = false;
                                    }
                                }
                                if (!r_gt) {
                                    if (r[t] > c) {
                                        r_gt = true;
                                    } else if (r[t] < c) {
                                        ok = false;
                                    }
                                }
                            }
                        }
                        if (ok) {
                            unsigned long long left = stoll2(
                                    l_lt
                                    ? l.substr(0, common) +
                                      string(i + len - common, c) +
                                      string(l.length() - i - len, '0')
                                    : l
                            );
                            unsigned long long right = stoll2(
                                    r_gt
                                    ? r.substr(0, common) +
                                      string(i + len - common, c) +
                                      string(r.length() - i - len, '9')
                                    : r
                            );
                            cnt += right - left + 1;
                        }
                    }
                } else {
                    for (char c = '0'; c <= '9'; c++) {
                        unsigned long long lb = 0, rb = 0;
                        unsigned long long scale = 1;
                        for (unsigned int j = common; j < i; j++) {
                            lb = lb * 10 + l[j];
                            rb = rb * 10 + r[j];
                        }
                        for (unsigned int j = i + len; j < l.length(); j++) {
                            scale *= 10;
                        }
                        cnt += (rb - lb - 1) * scale;

                        bool l_ok = true, l_lt = false;
                        bool r_ok = true, r_gt = false;
                        for (unsigned int t = i; t < i + len; t++) {
                            if (!l_lt && l_ok) {
                                if (l[t] < c) {
                                    l_lt = true;
                                } else if (l[t] > c) {
                                    l_ok = false;
                                }
                            }
                            if (!r_gt && r_ok) {
                                if (r[t] > c) {
                                    r_gt = true;
                                } else if (r[t] < c) {
                                    r_ok = false;
                                }
                            }
                        }

                        if (l_ok) {
                            if (l_lt) {
                                cnt += scale;
                            } else {
                                unsigned long long right = stoll2(
                                        l.substr(0, i) +
                                        string(len, c) +
                                        string(l.length() - i - len, '9')
                                );
                                cnt += right - stoll2(l) + 1;
                            }
                        }
                        if (r_ok) {
                            if (r_gt) {
                                cnt += scale;
                            } else {
                                unsigned long long left = stoll2(
                                        r.substr(0, i) +
                                        string(len, c) +
                                        string(r.length() - i - len, '0')
                                );
                                cnt += stoll2(r) - left + 1;
                            }
                        }
                    }
                }
            }
            if (cnt > 0) {
                cout << len << ' ' << cnt << '\n';
                return 0;
            }
        }
    }

}