#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

struct Point {
	ll x, y;

	Point() : x(), y() {}
	Point(ll _x, ll _y) : x(_x), y(_y) {}

	void scan() {
		scanf("%lld%lld", &x, &y);
	}

	Point operator + (const Point &a) const {
		return Point(x + a.x, y + a.y);
	}
	Point operator - (const Point &a) const {
		return Point(x - a.x, y - a.y);
	}
	ll operator % (const Point &a) const {
		return x * a.x + y * a.y;
	}
	ll operator * (const Point &a) const {
		return x * a.y - y * a.x;
	}

	bool operator < (const Point &a) const {
		if (x != a.x) return x < a.x;
		return y < a.y;
	}
};

const int N = 333;
int n, m;
Point a[N];
Point h[N];
bool bad[N][N];

bool cmp(const Point &v, const Point &u) {
	ll x = v * u;
	if (x != 0) return x > 0;
	return (v % v) < (u % u);
}

int sgn(ll x) {
	if (x == 0) return 0;
	if (x > 0)
		return 1;
	else
		return -1;
}

bool onDiffSides(Point A, Point a, Point P, Point Q) {
	return sgn((P - A) * a) * sgn((Q - A) * a) <= 0;
}

bool areIntersecting(Point A, Point B, Point C, Point D) {
	return onDiffSides(A, B - A, C, D) && onDiffSides(C, D - C, A, B);
}

void addSegm(int v, int u) {
	if (v > u) swap(v, u);
	assert(!bad[v][u]);
	bad[v][u] = 1;
	for (int i = 0; i < n; i++) {
		if (i == v || i == u) continue;
		for (int j = i + 1; j < n; j++) {
			if (j == v || j == u) continue;
			if (!bad[i][j] && areIntersecting(a[i], a[j], a[v], a[u]))
				bad[i][j] = 1;
		}
	}
}

void makeMove() {
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++) {
			if (bad[i][j]) continue;
			addSegm(i, j);
			printf("%d %d\n", i + 1, j + 1);
			fflush(stdout);
			return;
		}
	assert(false);
}

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		a[i].scan();
		h[i] = a[i];
	}
	Point minP = h[0];
	for (int i = 0; i < n; i++)
		if (h[i] < minP)
			minP = h[i];
	for (int i = 0; i < n; i++)
		h[i] = h[i] - minP;
	sort(h, h + n, cmp);
	int m = 1;
	for (int i = 1; i < n; i++) {
		while(m >= 2 && (h[m - 1] - h[m - 2]) * (h[i] - h[m - 1]) <= 0) m--;
		h[m++] = h[i];
	}
	int mv = 3 * n - 3 - m;
	printf("%d\n", 2 - (mv & 1));
	fflush(stdout);
	while(true) {
		if (mv & 1) {
			makeMove();
		} else {
			int v, u;
			scanf("%d%d", &v, &u);
			if (v == 0 && u == 0) {
				assert(mv == 0);
				return 0;
			}
			v--;u--;
			addSegm(v, u);
		}
		mv--;
	}

	return 0;
}
