/**
 * Sergey Kopeliovich (burunduk30@gmail.com)
 */

#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

struct Test {
	int id; // for multitest
	int n;
	int64_t W;
	vector<int> w, cost;

	void read(InStream &in) {
		n = in.readInt();
		W = in.readLong();
		w.resize(n);
		cost.resize(n);
		forn(i, n) {
			w[i] = in.readInt();
			cost[i] = in.readInt();
		}
	}

	void out() {
		printf("%d %" PRId64 "\n", n, W);
		forn(i, n)
			printf("%d %d\n", w[i], cost[i]);
	}
} test;

int64_t checkOutput(InStream &out, bool is_jury) {
	int k = out.readInt(0, test.n);
	unordered_set<int> used;
	int64_t sum_w = 0;
	int64_t sum_cost = 0;
	forn(i, k) {
		int id = out.readInt(1, test.n) - 1;
		if (!used.insert(id).second)
			out.quitf(_wa, "test #%d: index %d is used twice", test.id, id + 1);
		sum_w += test.w[id];
		sum_cost += test.cost[id];
	}
	bool bad = (sum_w > (is_jury ? test.W : 3 * test.W / 2));
	if (bad)
		out.quitf(_wa, "test #%d: W is %" PRId64 ", summary selected weight is %" PRId64, test.id, test.W, sum_w);
	return sum_cost;
}

int main(int argc, char *argv[]) {
	registerTestlibCmd(argc, argv);

	int64_t sum_n = 0;
	int tn = inf.readInt();

	for (int t = 1; t <= tn; t++) {
		test.id = t;
		test.read(inf);
		sum_n += test.n;

		auto ja = checkOutput(ans, 1);
		auto ca = checkOutput(ouf, 0);
		if (ca < ja) {
			// test.out();
			quitf(_wa, "test #%d: contestant says %" PRId64 ", answer to knapsack problem is %" PRId64, t, ca, ja);
		}
	}
	quitf(_ok, "OK (%d tests, average n is %.3f)", tn, (double)sum_n / tn);
}
