#include <cstdio>
#include <cassert>

#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <map>
#include <functional>
#include <algorithm>
#include <numeric>

#include "random.h"

using namespace std;

int __id = 1, argc;
char **argv;
#define GET(type, var) if (__id >= argc) Usage(); type var; { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define GET_GLOBAL(type, var) if (__id >= argc) Usage(); { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define GET_IF(type, var, default) type var; if (__id >= argc) var = default; else { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(a) (a).begin(), (a).end()

void Usage() {
	puts("Usage: <seed for random> <tn> <W> <n_small> <n>");
	puts("  [seed == 0] => Time()");
	puts("  generates big anti greedy test");
	exit(1);
}

int main(int _argc, char *_argv[]) {
	argc = _argc, argv = _argv;
	GET(int, seed);
	GET(int, tn);
	GET(int, W);
	GET(int, n_small);
	GET(int, n);

	ios_base::sync_with_stdio(false), cin.tie(0);

	if (seed == 0)
		seed = Time(), fprintf(stderr, "seed = %u\n", seed);
	initrand(seed);

	printf("%d\n", tn);

	int small = W / 5;
	int big = 3 * W / 4 + 1;

	while (tn--) {
		printf("%d %d\n", n, W);
		struct Item {
			int w, c, id;
		};
		vector<Item> test;
		vector<int> ans;
		int id_cnt = 0;

		int n0 = n_small;
		vector<int> p(n0 + 1);
		forn(i, n0 + 1)
			p[i] = R(0, small - n0);
		sort(all(p));
		forn(i, n0 + 1)
			p[i] += i;
		p[0] = 0, p[n0] = small;

		auto add_item = [&](int w, int c, bool in_ans = 0) {
			if (in_ans)
				ans.push_back(id_cnt);
			test.push_back({w, c, id_cnt++});
		};

		// build test
		forn(i, n0) {
			int w = p[i + 1] - p[i];
			add_item(w, w * 2, true);
		}

		add_item(1, 2 * W, true);

		int too_big_w = 3 * W / 2 + 1;
		add_item(too_big_w, 1e6);

		int last = -1;
		forn(i, n - n_small - 2)  {
			if (i % 10 == 0)
				last = id_cnt;
			add_item(big + i / 10, 2 * big + i / 10);
		}
		ans.push_back(last);

		// output test
		randomShuffle(all(test));
		vector<int> pos(id_cnt);
		forn(i, test.size()) {
			auto p = test[i];
			printf("%d %d\n", p.w, p.c), pos[p.id] = i;
		}

		fprintf(stderr, "%d\n", (int)ans.size());
		for (int id : ans)
			fprintf(stderr, "%d ", pos[id] + 1);
		fprintf(stderr, "\n");

		// next one should be bit different
		W--;
	}
}
