// 06.hand --> big test

#include <cstdio>
#include <cassert>

#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <map>
#include <functional>
#include <algorithm>
#include <numeric>

#include "random.h"

using namespace std;

int __id = 1, argc;
char **argv;
#define GET(type, var) if (__id >= argc) Usage(); type var; { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define GET_GLOBAL(type, var) if (__id >= argc) Usage(); { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define GET_IF(type, var, default) type var; if (__id >= argc) var = default; else { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(a) (a).begin(), (a).end()

void Usage() {
	puts("Usage: <seed for random> <tn> <W> <n>");
	puts("  [seed == 0] => Time()");
	puts("  generates big test from 06.hand");
	exit(1);
}

int main(int _argc, char *_argv[]) {
	argc = _argc, argv = _argv;
	GET(int, seed);
	GET(int, tn);
	GET(int, W);
	GET(int, n);

	int example_W = 100;
	vector<tuple<int, int, int>> example = {
		{6, 13, 0},
		{45, 91, 1},
		{45, 90, 0},
		{55, 108, 1},
		{100, 109, 0},
	};

	int n3 = (n - example.size()); // just trash
	int n1 = 100; // must have
	int n2 = 100; // big cost
	n3 -= n1 + n2;

	W -= n1;
	W -= W % example_W;

	ios_base::sync_with_stdio(false), cin.tie(0);

	if (seed == 0)
		seed = Time(), fprintf(stderr, "seed = %u\n", seed);
	initrand(seed);

	printf("%d\n", tn);

	while (tn--) {
		printf("%d %d\n", n, W + n1);
		assert(W % example_W == 0);
		int coef = W / example_W;

		struct Item {
			int w, c, id;
		};
		vector<Item> test;
		vector<int> ans;
		int id_cnt = 0;

		auto add_item = [&](int w, int c, bool in_ans = 0) {
			if (in_ans)
				ans.push_back(id_cnt);
			test.push_back({w, c, id_cnt++});
		};

		for (auto [w, c, need] : example)
			add_item(w * coef, c * coef, need);

		auto big_w = get<0>(example.back()) * coef;
		auto big_c = get<1>(example.back()) * coef;
		forn(i, n1)
			add_item(1, R(W / 2, W), 1);
		forn(i, n2)
			add_item(big_w - i - 1, big_c - i - 1);
		forn(i, n3)
			add_item(R(W / 4, W), 1);

		// output test
		randomShuffle(all(test));
		vector<int> pos(id_cnt);
		forn(i, test.size()) {
			auto p = test[i];
			printf("%d %d\n", p.w, p.c), pos[p.id] = i;
		}

		fprintf(stderr, "%d\n", (int)ans.size());
		for (int id : ans)
			fprintf(stderr, "%d ", pos[id] + 1);
		fprintf(stderr, "\n");

		// next one should be bit different
		W -= example_W;
	}
}
