#include <cstdio>
#include <cassert>

#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <map>
#include <functional>
#include <algorithm>
#include <numeric>

#include "random.h"

using namespace std;

int __id = 1, argc;
char **argv;
#define GET(type, var) if (__id >= argc) Usage(); type var; { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define GET_GLOBAL(type, var) if (__id >= argc) Usage(); { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define GET_IF(type, var, default) type var; if (__id >= argc) var = default; else { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(a) (a).begin(), (a).end()

void Usage() {
	puts("Usage: <seed for random> <tn> <W> <c> <n1> <n2=n1>");
	puts("  [seed == 0] => Time()");
	puts("  generates random test tn n W with w in [1..c/100] and cost in [1..c]");
	exit(1);
}

int main(int _argc, char *_argv[]) {
	argc = _argc, argv = _argv;
	GET(int, seed);
	GET(int, tn);
	GET(int, W);
	GET(int, c);
	GET(int, n1);
	GET_IF(int, n2, n1);

	ios_base::sync_with_stdio(false), cin.tie(0);

	if (seed == 0)
		seed = Time(), fprintf(stderr, "seed = %u\n", seed);
	initrand(seed);

	printf("%d\n", tn);
	while (tn--) {
		int n = R(n1, n2);
		printf("%d %d\n", n, W);
		forn(i, n)
			printf("%d %d\n", R(1, c / 100), R(1, c));
	}
}
