#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

struct Item {
	int id;
	ll w, c;

	Item() : id(), w(), c() {}
	Item(int _id, ll _w, ll _c) : id(_id), w(_w), c(_c) {}

	void scan(int _id) {
		id = _id;
		scanf("%lld%lld", &w, &c);
	}

	bool operator < (const Item &I) const {
		return c * I.w > I.c * w;
	}
};

vector<Item> small, big;
vector<ll> prefW;
vector<ll> prefC;
int n;
ll W;
int bst;
ll ANS;

ll getCost(ll w) {
	assert(w <= W);
	w = W - w;
	int pos = upper_bound(all(prefW), w) - prefW.begin();
	if (pos == (int)prefW.size()) pos--;
	return prefC[pos];
}
vector<int> getIds(ll w) {
	assert(w <= W);
	w = W - w;
	int pos = upper_bound(all(prefW), w) - prefW.begin();
	if (pos == (int)prefW.size()) pos--;
	vector<int> res;
	for (int i = 0; i < pos; i++)
		res.push_back(small[i].id);
	return res;
}


void solve() {
	scanf("%d%lld", &n, &W);
	small.clear();
	big.clear();
	for (int i = 0; i < n; i++) {
		Item I;
		I.scan(i + 1);
		if (I.w > W) continue;
		if (2 * I.w > W)
			big.push_back(I);
		else
			small.push_back(I);
	}
	sort(all(small));
	prefW = vector<ll>((int)small.size() + 1, 0);
	prefC = vector<ll>((int)small.size() + 1, 0);
	for (int i = 0; i < (int)small.size(); i++) {
		prefW[i + 1] = prefW[i] + small[i].w;
		prefC[i + 1] = prefC[i] + small[i].c;
	}
	bst = -1;
	ANS = getCost(0);
	for (int i = 0; i < (int)big.size(); i++) {
		ll cur = getCost(big[i].w) + big[i].c;
		if (cur > ANS) {
			ANS = cur;
			bst = i;
		}
	}
	vector<int> ans;
	if (bst == -1) {
		ans = getIds(0);
	} else {
		ans = getIds(big[bst].w);
		ans.push_back(big[bst].id);
	}
	sort(all(ans));
	printf("%d\n", (int)ans.size());
	for (int x : ans)
		printf("%d ", x);
	printf("\n");
}

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	int t;
	scanf("%d", &t);
	while(t--) solve();

	return 0;
}
