/**
 * Sergey Kopeliovich (burunduk30@gmail.com)
 */

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(a) a.begin(), a.end()

void solve() {
	int n;
	int64_t W;
	cin >> n >> W;
	struct Item {
		int w, cost, id;
	};
	vector<Item> greedy, brute;
	forn(i, n) {
		Item it;
		cin >> it.w >> it.cost, it.id = i;
		if (it.w <= W)
			(2 * it.w > W ? brute : greedy).push_back(it);
	}
	brute.push_back({0, 0, -1}); // do not take anything

	sort(all(greedy), [](auto a, auto b) {
		return (int64_t)a.cost * b.w > (int64_t)b.cost * a.w;
	});
	sort(all(brute), [](auto a, auto b) {
		return a.w > b.w;
	});

	int64_t best = 0, sum_w = 0, sum_cost = 0, tmp;
	int best_i = 0, j = 0;
	W = 3 * W / 2;
	forn(i, brute.size()) {
		while (j < (int)greedy.size() && sum_w + greedy[j].w + brute[i].w <= W) {
			// printf("i = %d : take j = %d <%d,%d>\n", i, j, greedy[j].w, greedy[j].cost);
			sum_cost += greedy[j].cost, sum_w += greedy[j++].w;
		}
		if (best < (tmp = sum_cost + brute[i].cost))
			best = tmp, best_i = i;
	}
	// cout << best << " " << best_i << endl;

	vector<int> ans;
	sum_w = brute[best_i].w;
	if (brute[best_i].id != -1)
		ans.push_back(brute[best_i].id);
	for (auto it : greedy)
		if ((sum_w += it.w) <= W)
			ans.push_back(it.id);

	cout << ans.size() << "\n";
	for (int i : ans)
		cout << i + 1 << " ";
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);

	int tn;
	cin >> tn;
	while (tn--)
		solve();
}
