/**
 * Sergey Kopeliovich (burunduk30@gmail.com)
 */

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(a) a.begin(), a.end()

void solve() {
	int n;
	int64_t W;
	cin >> n >> W;
	struct Item {
		int w, cost, id;
	};
	vector<Item> a(n);
	forn(i, n)
		cin >> a[i].w >> a[i].cost, a[i].id = i;

	sort(all(a), [](auto a, auto b) {
		return (int64_t)a.cost * b.w > (int64_t)b.cost * a.w;
	});

	int64_t best = 0;
	vector<int> ans;
	vector<int> skipped;
	auto relax = [&](bool f = 0) {
		int64_t sum_w = 0, sum_cost = 0;
		vector<int> ids;
		forn(i, n)
			if (sum_w + a[i].w <= 3 * W / 2) {
				sum_w += a[i].w;
				sum_cost += a[i].cost;
				ids.push_back(a[i].id);
			} else if (f) {
				skipped.push_back(i);
			}
		if (sum_cost > best)
			best = sum_cost, ans = ids;
	};
	relax(1);

	int sn = skipped.size(), K = 5;
	forn(i, sn)
		if (i < K || i + K >= sn) {
			int x = skipped[i];
			rotate(a.begin(), a.begin() + x, a.begin() + x + 1);
			relax();
			rotate(a.begin(), a.begin() + 1, a.begin() + x + 1); // rotate back
		}

	cout << ans.size() << "\n";
	for (int i : ans)
		cout << i + 1 << " ";
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);

	int tn;
	cin >> tn;
	while (tn--)
		solve();
}
